/* $Header: /a/pluto/vol/fileservers/Pluto/Pluto2/src/X500/xd/work/src/query_engine/RCS/dn_list.h,v 1.0 92/11/27 16:57:35 emsrdsm Exp Locker: emsrdsm $ */

#ifndef _query_entry_list_h_
#define _query_entry_list_h_

#include "types.h"
#include <quipu/attr.h>

typedef struct ent_list
{
  char *string_dn;
  char *sort_key;
  AttributeType object_class;
  struct ent_list *next;
} entry_list, *entryList;

#define NULLEntryList (entryList) NULL
#define entry_list_alloc() (entryList) smalloc(sizeof(entry_list))

void dn_list_free(), dn_list_copy();
QBool dn_list_add(), dn_list_merge(), dn_list_insert();

#endif _query_entry_list_h_




